/***************************************************************
* file name			: spi_flash.h

* Description   : spiflashغָ

* Author    		: zc

* Version				: 0.1

* Date					: 2015.9.12

* History       
***************************************************************/
#include "spi_flash.h"

/****************************************************************
* function   	: SPI1_GPIO_Config

* Description : SPI1(ΪSDⲿflashSPI˿ڣҪ
								ȡSDƬѡ, )
								SD_CS	: SDƬѡ			PD11
								SPI_CS:	SPIƬѡ 		PB9
								SCK		: ʱӶ			 	PA5
								MISO	:  	PA6
								MOSI	 	PA7
								
* input			  : 

* output      : 
*****************************************************************/
void SPI1_GPIO_Config(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB 
												|RCC_APB2Periph_GPIOD | RCC_APB2Periph_AFIO, ENABLE);
	
	
	/*SD_CS Disable PD11*/
	GPIO_InitStructure.GPIO_Pin  = SD_CS_Pin;
	GPIO_InitStructure.GPIO_Speed= GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(SD_CS_Port, &GPIO_InitStructure);
  GPIO_SetBits(SD_CS_Port, SD_CS_Pin);
	
	/*SPI1_CS ˿*/
	GPIO_InitStructure.GPIO_Pin  = SPI1_CS_Pin;
  GPIO_Init(SPI1_CS_Port, &GPIO_InitStructure);
  SPI1_CS_Disable();
	
	/*SPI1_SCK ˿*/
	GPIO_InitStructure.GPIO_Pin  = SPI1_SCK_Pin;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(SPI1_SCK_Port, &GPIO_InitStructure);
	
	/*SPI1_MISO ˿*/
	GPIO_InitStructure.GPIO_Pin  = SPI1_MISO_Pin;
  GPIO_Init(SPI1_MISO_Port, &GPIO_InitStructure);
	
	/*SPI1_MOSI ˿*/
	GPIO_InitStructure.GPIO_Pin  = SPI1_MOSI_Pin;
	GPIO_Init(SPI1_MOSI_Port, &GPIO_InitStructure);
}

/****************************************************************
* function   	: SPI1_MODE_Config

* Description : SPI1ʽ
								
* input			  : 

* output      : 
*****************************************************************/
void SPI1_MODE_Config(void)
{
	SPI_InitTypeDef  SPI_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1 | RCC_APB2Periph_AFIO, ENABLE);
	
	SPI_InitStructure.SPI_Direction =	SPI_Direction_2Lines_FullDuplex;	//SPI˫˫ģʽ
	SPI_InitStructure.SPI_Mode			= SPI_Mode_Master;									//CPUSPIģʽ
	SPI_InitStructure.SPI_DataSize  = SPI_DataSize_8b;									//SPI֡Ϊ8ֽ
	SPI_InitStructure.SPI_CPOL      = SPI_CPOL_High;										//ʱSCKߵƽ	MODE3ģʽ
	SPI_InitStructure.SPI_CPHA			=	SPI_CPHA_2Edge;										//ڶ½ؽ/		
	SPI_InitStructure.SPI_NSS				= SPI_NSS_Soft;											//豸
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4;  //ΪPclk2/4
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;									//λȷ
  SPI_InitStructure.SPI_CRCPolynomial = 7;														//ĬCRCУʽ 
	
	SPI_Init(SPI1, &SPI_InitStructure);
	SPI_Cmd(SPI1, ENABLE);
}


/****************************************************************
* function   	: SPI_Flash_SendByt

* Description : SPI1ֽ
								
* input			  : 

* output      : 
*****************************************************************/
uint8_t SPI_SendWrite_Byte(uint8_t byte)
{
  /*ȴSPIݼĴΪʱ1ֽ*/
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET)
	{
	}
  SPI_I2S_SendData(SPI1, byte);
 
	/*ڷͬʱSPI_MISOŻȡܽݣȴȡĴǿ*/
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET)
	{
	}
  return SPI_I2S_ReceiveData(SPI1);
}

/****************************************************************
* function   	: SPI_Write_Enable

* Description : ʹⲿflashдģʽ
								
* input			  : 

* output      : 
*****************************************************************/
void SPI_Write_Enable(void)
{
	SPI1_CS_Enable();
	SPI_SendWrite_Byte(Flash_WriteEnable);
	SPI1_CS_Disable();
}

/****************************************************************
* function   	: SPI_WaitWriteEnd

* Description : ͨȡSPI״̬ĴжSPI
								
* input			  : 

* output      : 
*****************************************************************/
static void SPI_WaitWriteEnd(void)
{
	uint8_t Flash_Status = 0;
	SPI1_CS_Enable();
	Flash_Status = SPI_SendWrite_Byte(Flash_ReadStatusReg);
	while((Flash_Status & 0x01) == SET)
	{
		Flash_Status = SPI_SendWrite_Byte(Flash_NoBusy);	//0xff豸ṩʱӣȡ
	}
	SPI1_CS_Disable();
}

/****************************************************************
* function   	: SPI_EraseSector

* Description : ַָӦ
								
* input			  : SectorAddressȴеĵַ

* output      : 
*****************************************************************/
void SPI_EraseSector(u32 SectorAddress)
{
	SectorAddress = (SectorAddress>>12)<<12; //ȷ׵ַ
	SPI_Write_Enable();											 //д
	
	SPI1_CS_Enable();
	SPI_SendWrite_Byte(Flash_SectorErase);   //дָ
	
	/*д*/
	SPI_SendWrite_Byte((SectorAddress&0xFF0000)>>16);
	SPI_SendWrite_Byte((SectorAddress&0xFF00)>>8);
	SPI_SendWrite_Byte(SectorAddress&0xFF);
	SPI1_CS_Disable();
	
	SPI_WaitWriteEnd();
}

/****************************************************************
* function   	: SPI_PageWrite

* Description : ַָָд
								
* input			  : pBuffer			͵׵ַ
								PageAddres	λflashеĵַ	
								WriteByteNumݳ

* output      : 
*****************************************************************/
void SPI_PageWrite(u8 *pBuffer, u32 PageAddress,u16 WriteByteNum)
{
	SPI_Write_Enable();											//д
	
	SPI1_CS_Enable();
	SPI_SendWrite_Byte(Flash_PageProgram);	//д洢ָ
	SPI_SendWrite_Byte(PageAddress >> 16);	//д洢ַ
	SPI_SendWrite_Byte(PageAddress >> 8);
	SPI_SendWrite_Byte(PageAddress);
  
	if(WriteByteNum > 256) 								
	{
		WriteByteNum = 256;
		printf("\n\r Err: SPI_PageWrite too large!");
	}
 
	/*д*/
	while(WriteByteNum--)
	{
		SPI_SendWrite_Byte(*pBuffer);
		pBuffer++;
	}
  SPI1_CS_Disable();
	
	SPI_WaitWriteEnd();
}

/****************************************************************
* function   	: SPI_EraseBlock

* Description : տָⲿflash
								
* input			  :	BlockAddressȴеĵַ
							
* output      : 
*****************************************************************/
void SPI_EraseBlock(u32 BlockAddress)
{
	SPI_Write_Enable();
	
	SPI1_CS_Enable();
	SPI_SendWrite_Byte(Flash_BlockErase);
	SPI_SendWrite_Byte(BlockAddress >> 16);
	SPI_SendWrite_Byte(BlockAddress >> 8);
	SPI_SendWrite_Byte(BlockAddress);
 
	SPI1_CS_Disable();
	SPI_WaitWriteEnd();
}

/****************************************************************
* function   	: SPI_Read

* Description : ַָָȡ
								
* input			  : pBuffer			洢ȡݵ׵ַ
								PageAddres	ȡλflashеĵַ	
								WriteByteNumȡݳ

* output      : 
*****************************************************************/
void SPI_Read(u8 *pBuffer,u32 ReadAddress,u16 ReadByteNum)
{
	SPI1_CS_Enable();
	
	SPI_SendWrite_Byte(Flash_ReadData);    //дȡָ
	SPI_SendWrite_Byte(ReadAddress >> 16); //дȡݵַ
	SPI_SendWrite_Byte(ReadAddress >> 8);
	SPI_SendWrite_Byte(ReadAddress);
 
	/*ȡ*/
	while(ReadByteNum--)
	{
		*pBuffer = SPI_SendWrite_Byte(Flash_NoBusy);
		pBuffer++;
	}
	SPI1_CS_Disable();
}
 
/****************************************************************
* function   	: SPI_PowerDown

* Description : ⲿflashڵģʽ
								
* input			  : 

* output      : 
*****************************************************************/
void SPI_PowerDown(void)   
{ 
   SPI1_CS_Enable();
 
	 SPI_SendWrite_Byte(Flash_PowerDown);
 
   SPI1_CS_Disable();
}   
/****************************************************************
* function   	: Flash_WakeUp

* Description : ⲿflash
								
* input			  : 

* output      : 
*****************************************************************/
void SPI_WakeUp(void)   
{
  SPI1_CS_Enable();
 
  SPI_SendWrite_Byte(Flash_ReleasePowerDown);
 
  SPI1_CS_Disable();            
}  

/****************************************************************
* function   	: ȡflashID

* Description : ⲿflash
								
* input			  : 

* output      : 
*****************************************************************/
u32 SPI_ReadID(void)
{
	u32 ID_Temp,temp_h,temp_m,temp_l;
 
	SPI1_CS_Enable();
	SPI_SendWrite_Byte(Flash_JedecDeviceID);
 
  temp_h = SPI_SendWrite_Byte(Flash_NoBusy);
	temp_m = SPI_SendWrite_Byte(Flash_NoBusy);
	temp_l = SPI_SendWrite_Byte(Flash_NoBusy);
	SPI1_CS_Disable();
 
	ID_Temp = (temp_h << 16)|(temp_m << 8)|temp_l;
	return ID_Temp;
}
