/***************************************************************
* file name			: spi_flash.h

* Description   : ʵspiⲿflash

* Author    		: zc

* Version				: 0.1

* Date					: 2015.9.12

* History       
***************************************************************/
#ifndef _SPI_FLASH_H
#define _SPI_FLASH_H

#include "stm32f10x.h"
#include <stdio.h>

#define SD_CS_Pin 	GPIO_Pin_11
#define	SD_CS_Port	GPIOD

/*SPI */
#define SPI1_CS_Pin 		GPIO_Pin_9		//PB9
#define SPI1_CS_Port		GPIOB
#define SPI1_SCK_Pin 		GPIO_Pin_5		//PA5
#define SPI1_SCK_Port		GPIOA
#define SPI1_MISO_Pin 	GPIO_Pin_6		//PA6
#define SPI1_MISO_Port	GPIOA
#define SPI1_MOSI_Pin		GPIO_Pin_7		//PA7
#define SPI1_MOSI_Port	GPIOA

#define SPI1_CS_Enable() 	GPIO_ResetBits(SPI1_CS_Port, SPI1_CS_Pin)
#define SPI1_CS_Disable() GPIO_SetBits(SPI1_CS_Port, SPI1_CS_Pin)

/*ⲿflashָ*/
#define Flash_WriteEnable				0x06 
#define Flash_WriteDisable			0x04 
#define Flash_ReadStatusReg			0x05 
#define Flash_WriteStatusReg		0x01 
#define Flash_ReadData					0x03 
#define Flash_FastReadData			0x0B 
#define Flash_FastReadDual			0x3B 
#define Flash_PageProgram				0x02 
#define Flash_BlockErase				0xD8 
#define Flash_SectorErase				0x20 
#define Flash_ChipErase					0xC7 
#define Flash_PowerDown					0xB9 
#define Flash_ReleasePowerDown	0xAB 
#define Flash_ManufactDeviceID	0x90 
#define Flash_JedecDeviceID			0x9F 
#define Flash_NoBusy						0xFF

u32 Flash_ReadID(void);
void SPI_PageWrite(u8 *pBuffer,u32 PageAddress,u16 WriteByteNum);
void SPI_Read(u8 *pBuffer,u32 ReadAddress,u16 ReadByteNum);
void SPI_EraseBlock(u32 BlockAddress);
void SPI_EraseSector(u32 SectorAddress);
void SPI1_MODE_Config(void);
void SPI1_GPIO_Config(void);
u32 SPI_ReadID(void);
void SPI_PowerDown(void);
void SPI_WakeUp(void);
#endif
