/***************************************************************
* file name			: main.c

* Description   : ʵADCԼADCͨDMA

* Author    		: zc

* Version				: 0.1

* Date					: 2015.4.22

* History       
***************************************************************/

#include "stm32f10x.h"
#include "user_config.h"
#include <stdio.h>
#include "string.h"

u32 DeviceID;
u8  ts_data[10]=
{
	0x30, 0x31, 0x32, 0x33, 0x34,
	0x35, 0x36, 0x37, 0x38, 0x39,
};
u8  buffer1[11];
u8  buffer2[11];
u8  uDeviceID[9];
#define FLASH_Address 	0x00000000
void IntToAsc(u32 num, u8 len);

/****************************************************************
* function   	: main

* Description : spiܲԺʵ
								
* input			  : 

* output      : 
*****************************************************************/
int main(void)
{	
	  BSP_Init();
		
		DeviceID = SPI_ReadID();
	  IntToAsc(DeviceID, 8);
		uDeviceID[8] = '\0';
	 
	  memset(buffer1, 0, sizeof(buffer1));
		memset(buffer2, 0, sizeof(buffer2));
		SPI_EraseSector(FLASH_Address);
		SPI_Read(buffer1, FLASH_Address, sizeof(ts_data));
		buffer1[10] = '\0';
		SPI_PageWrite(ts_data, FLASH_Address, sizeof(ts_data));
	  SPI_Read(buffer2, FLASH_Address, sizeof(ts_data));
	  buffer2[10] = '\0';
	  
    while (1)
    {  
			printf("DeviceId: 0x%s\n", uDeviceID);
			ARM_DELAY(2000000);
			
			if(0xff == buffer1[0])
			{
				LED1_ON;
				printf("SPI Flash Erase Success\n");
			}
			
			ARM_DELAY(2000000);
			printf("Read Write Buffer: %s\n", buffer2);
			ARM_DELAY(2000000);
	  }
}


void IntToAsc(u32 num, u8 len)
{
	u8 i;
	u8 mov;
	u8 c;
	for(i=0; i<len; i++)
	{
		mov = (len-i-1)*4;
		c = num>>mov&0x0f;
		if(c > 9)
		{
			c = c - 10 + 'A';
		}
		else
		{
			c = c + '0';
		}
		
		uDeviceID[i] = c;
	}
}

